import javax.swing.*;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.awt.*;
/**
 * Generates a new Gamewindow with Swing Framework
 * 
 * @author Michael (saremox) Straßberger <3strassb@informatik.uni-hamburg.de>
 * @version 2013-11-01
 */
public class GameWindow extends JFrame
{
    private BufferedImage doublebuffer;
    private Graphics2D db_g;
    private GameObjects _gobj;
    
    
    public GameWindow(GameObjects gameobj)
    {
        _gobj = gameobj;
        
        Dimension desktop = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        int offset_x,offset_y;
        
        offset_x = (desktop.width-1280) / 2;
        offset_y = (desktop.height-720) / 2;
        
        // Setup Game window
        this.setSize(1280  ,720);
        this.setResizable(false);
        this.setLocation(1920, 25);
        this.setTitle("BlueJ - Game Window");
        //this.setDefaultCloseOperation(JFrame.CLOSE_ON_EXIT);
        
        // Setup Doublebuffering
        
        doublebuffer = new BufferedImage(1280,720,BufferedImage.TYPE_INT_RGB);
        db_g =(Graphics2D) doublebuffer.getGraphics();
        
        this.setVisible(true);
    }
    
    private void render(Graphics2D g)
    {
        if(_gobj.getSize()>0)
        {
            Object[] tmpObjList = _gobj.getArray();
            int i = _gobj.getSize();
            while(i >= 0)
            {
                try {
                    ((Drawable) tmpObjList[i]).draw(g);

                }
                catch(java.lang.ArrayIndexOutOfBoundsException e)
                {
                }
                i--;
            }      

        }
    }
    
    public void update(Graphics g)
    {
        // Only Clear the buffer.
       
    }
    
    public void paint(Graphics g)
    {
        db_g.setColor(Color.black);
        db_g.fillRect(0, 0, 1280, 720);
        this.render(db_g);
        g.drawImage(doublebuffer,0,0,null);
    }
}
