import java.awt.Point;
/**
 * Vertex Class that Handles Point Conversion and used for easier Physics implementation
 * 
 * @author Michael Straßberger <3strassb@informatik.uni-hamburg.de> 
 * @version 2013-11-02
 */
public class Vertex3D
{
    // instance variables - replace the example below with your own
    private double _x;
    private double _y;
    private double _z;

    
    public Vertex3D(double x, double y, double z)
    {
        _x = x;
        _y = y;
        _z = z;
    }
    
    public Vertex3D(double x, double y)
    {
        _x = x;
        _y = y;
        _z = 0;
    }
    
    public double getX()
    {
        return _x;
    }

    public double getY()
    {
        return _y;
    }
    
    public double getYConv()
    {
        return (double) 720-_y;
    }

    public double getZ()
    {
        return _z;
    }

    public void setX(double x)
    {
        _x = x;
    }

    public void setY(double y)
    {
        _y = y;
    }

    public void setZ(double z)
    {
        _z = z;
    }

    public void incX(double x)
    {
        _x += x;
    }

    public void incY(double y)
    {
        _y += y;
    }

    public void incZ(double z)
    {
        _z += z;
    }

    public void decX(double x)
    {
        _x -= x;
    }

    public void decY(double y)
    {
        _y -= y;
    }

    public void decZ(double z)
    {
        _z -= z;
    }

    public Point toPoint()
    {
        return new Point((int) _x,(int) (720-_y) );
    }
}
